// -*-c++-*-
# ifndef RepetitionSentry_h
# define RepetitionSentry_h

# include <TranspositionTable/HashTable.h>
# include <vector>
namespace Alice
{
class RepetitionSentry
  : public HashTable
{
public:
  RepetitionSentry();
  virtual ~RepetitionSentry();
  bool isRepeatedPosition();
  virtual void update();
  virtual void downdate();
private:
  struct Entry
  {
    uint64 identifier;
    int occurences;
    Entry():identifier(0), occurences(0){};
  };
  std::vector<Entry> entries;
};
}; // namespace Alice
# endif // RepetitionSentry_h
